unit USB_In_Out;

interface
   uses Windows;

type
    _lIn  =  record
                bFunction : Byte;
                bValue1   : Byte;
                bValue2   : Byte;
             end;
             
    _lOut  = record
                bAck    : Byte;
                bValue1 : Byte;
                bValue2 : Byte;
             end;

      procedure USB_IO;
      function  Port0Read                       : Integer;
      function  Port1Read                       : Integer;
      procedure Port0Write   (Wert:      Byte);
      procedure Port1Write   (Wert:      Byte);
      procedure Port0PullUp  (Wert:      Byte);
      procedure Port1PullUp  (Wert:      Byte);
      procedure Port0ISink   (Pin, Wert: Byte);    //Pin 0 bis 7
      procedure Port1ISink   (Pin, Wert: Byte);    //Pin 0 bis 3

var
    lIn           : _lIn;
    lOut          : _lOut;
    DeviceHandle  : THandle;
    TemplateHandle: THandle;
    nBytes        : DWord;
    bresult       : Boolean;

//............................................................................

implementation

//.............................................................................

procedure USB_IO;
begin
  bResult := DeviceIoControl(DeviceHandle,$04,@lIn,sizeof(lIn),@lOut, sizeof (lOut),nBytes,nil);
end;
//.............................................................................

function Port0Read:   Integer;
begin
  lIn.bFunction := 20;
  lIn.bValue1   := 0;
  USB_IO;
  Result := lOut.bValue1;
end;
//...........................................................................

function Port1Read:   Integer;
begin
  lIn.bFunction := 20;
  lIn.bValue1   := 1;
  USB_IO;
  Result := lOut.bValue1;
end;
//...........................................................................

procedure Port0Write(Wert : Byte);
begin
  lIn.bFunction := 21;
  lIn.bValue1   := 0;
  lIn.bValue2   := Wert;
  USB_IO;
end;
//.............................................................................

procedure Port1Write(Wert : Byte);
begin
  lIn.bFunction := 21;
  lIn.bValue1   := 1;
  lIn.bValue2   := Wert;
  USB_IO;
end;
//.............................................................................

procedure Port0PullUp(Wert : Byte);
begin
  lIn.bFunction :=23;
  lIn.bValue1   :=16;
  lIn.bValue2   :=255-Wert;
  USB_IO;
end;
//.............................................................................

procedure Port1PullUp(Wert : Byte);
begin
  lIn.bFunction :=23;
  lIn.bValue1   :=17;
  lIn.bValue2   :=15-Wert;
  USB_IO;
end;
//.............................................................................

procedure Port0ISink(Pin, Wert : Byte);
begin
  lIn.bFunction:=23;
  lIn.bValue1  :=Pin;
  lIn.bValue2  :=Wert;
  USB_IO;
end;
//.............................................................................

procedure Port1ISink(Pin, Wert : Byte);
begin
  lIn.bFunction:=23;
  lIn.bValue1  :=Pin+8;
  lIn.bValue2  :=Wert;
  USB_IO;
end;
//.............................................................................

end.
 